/* ANIMATE.c -- Example 6 - Animation */

#include <windows.h>
#include <time.h>
#include "pv.h"
#include "ANIMATE.h"

/*  Handles to View and View Window */
HANDLE   gblInstance;
VIEW     Animate;
HWND     hWndAnimate;

int PASCAL WinMain(hInstance, hPrevInstance, lpszCmdLine, nCmdShow)
    HANDLE     hInstance, hPrevInstance;
    LPSTR      lpszCmdLine;
    int        nCmdShow;
{
   static char szAppName[] = "ANIMATE";
   MSG      msg;

   gblInstance = hInstance;
/*  Obtain FarProc address for View subclassing funtions  */
   lpfnAnimateWndProc = (VIEWPROC)MakeProcInstance((FARPROC)AnimateWndProc, hInstance);
   lpfnMakeLongPointer = MakeProcInstance(MakeLongPointer, hInstance);

/* vwCreateView opens the view and populates it with field controls *
 * from a resource file.                                            */
   if(!(Animate = vwCreateView(hInstance,
                   "Animate",
                   NULL,
                   lpfnAnimateWndProc,
                   lpfnMakeLongPointer)))
        return FALSE;

   vwSetViewIcon(Animate, LoadIcon(hInstance, "Animate")); // Attach an icon


   /*InitAnimateBEGIN*/
   /*InitAnimateEND*/

   if(!(hWndAnimate = vwShowView(Animate)))
   {
        MessageBox(NULL, "Unable to display view", "System Error",
                   MB_SYSTEMMODAL | MB_ICONHAND | MB_OK);
        return FALSE;
   }

   while(GetMessage(&msg, NULL, 0, 0))
   {
       TranslateMessage(&msg);
       DispatchMessage(&msg);
   }
   /*TermAnimateBEGIN*/
   /*TermAnimateEND*/

   FreeProcInstance((FARPROC)lpfnAnimateWndProc);
   FreeProcInstance(MakeLongPointer);

   return msg.wParam;
}

long FAR PASCAL AnimateWndProc(HWND hWnd, WORD wMessage, WORD wParam, LONG lParam)
{
   GETVIEW;
   /*AnimateWndProcBEGIN*/


   switch(wMessage)
   {
       case WM_INITDIALOG :
          PostMessage(hWnd, WM_USER, 5, MAKELONG(2, BN_CLICKED));
          break;

       case WM_USER :
           vwAnimateField(View, 1, 72, 10, 500, 10, NULL);
           break;

       case WM_COMMAND :
           if(HIWORD(lParam) == BN_CLICKED)
              switch(wParam)
              {
                 case 3 :
                    vwHideField(View, 5);
                    vwAnimateField(View, 1, 72, -118, 500, 10, NULL);
                    vwWait(View, 500);
                    vwAnimateField(View, 3, -65, 154, 500, 10, NULL);
                    vwWait(View, 500);
                    vwAnimateField(View, 4, 385, 154, 500, 10, NULL);
                    vwWait(View, 500);
                    vwAnimateField(View, 2, 70, -60, 500, 10, NULL);
                    vwWait(View, 500);

              }
              break;

       case WM_DESTROY :
              PostQuitMessage(0);
              break;
   /*AnimateWndProcEND*/

   }
   return DefViewProc(hWnd, wMessage, wParam, lParam);
}

BOOL FAR PASCAL MakeLongPointer()
{
static void far *Ptr;
   Ptr = &Ptr;
   return(HIWORD(Ptr));
}
// Code regeneration bracket
   /*CustomCodeBEGIN*/
   /*CustomCodeEND*/

